#property copyright "Copyright  2009, CoolMan"
#property link      ""

extern string Name = "++++++++ Parabolic ++++++++";
extern string Cop = "++ Copyright  2009, CoolMan ++";
extern int StopLoss = 100;
extern int TrailingStop = 0;
extern string SARfast = " ";
extern double stepfast = 0.02;
extern double maximumfast = 0.2;
extern string SARslow = " ";
extern double stepslow = 0.005;
extern double maximumslow = 0.05;
extern string MA = "  ";
extern int perMA = 3;
extern string fibo = "  ";
extern double Ur1 = 50.0;
extern double Ur2 = 161.0;
extern int MagicNumber = 100;
extern int risk = 50;
double gd_192 = 0.1;
int gi_unused_200;
int gi_unused_204;
int g_bars_208;
int gi_212;
bool gi_216;
bool gi_220;

int start() {
   if (g_bars_208 != Bars) {
      if (Control() == 1) {
         g_bars_208 = Bars;
         gi_212 = ScalpParabolicPattern();
      }
   }
   if (TrailingStop > 0) gi_212 = CheckTrailingStop();
   return (0);
}

double Lots() {
   double l_minlot_0 = MarketInfo(Symbol(), MODE_MINLOT);
   double l_maxlot_8 = MarketInfo(Symbol(), MODE_MAXLOT);
   gd_192 = NormalizeDouble(AccountFreeMargin() * risk / 500000.0, 1);
   if (l_minlot_0 > gd_192) gd_192 = l_minlot_0;
   if (gd_192 > l_maxlot_8) gd_192 = l_maxlot_8;
   return (gd_192);
}

int Control() {
   bool li_ret_0 = TRUE;
   int li_4 = 2222; //     
   if (TimeYear(TimeCurrent()) > li_4) li_ret_0 = FALSE;
   return (li_ret_0);
}

int ScalpParabolicPattern() {
   int l_ticket_0;
   double ld_4;
   double l_price_12;
   double l_price_20;
   double l_high_28;
   double ld_36;
   double ld_44;
   double ld_52;
   double l_isar_60 = iSAR(NULL, 0, stepslow, maximumslow, 1);
   double l_isar_68 = iSAR(NULL, 0, stepfast, maximumfast, 1);
   double l_isar_76 = iSAR(NULL, 0, stepfast, maximumfast, 1);
   if (l_isar_68 > Bid && l_isar_60 < Bid) gi_216 = TRUE;
   if (l_isar_60 > Bid) gi_216 = FALSE;
   if (l_isar_68 < Bid && l_isar_60 > Bid) gi_220 = TRUE;
   if (l_isar_60 < Bid) gi_220 = FALSE;
   if (l_isar_60 < Bid && l_isar_68 < Bid && gi_216 == TRUE) {
      gi_216 = FALSE;
      ld_36 = MaximumMinimum(0, perMA);
      l_high_28 = High[1];
      ld_44 = GetFiboUr(l_high_28, ld_36, Ur1 / 100.0);
      ld_52 = GetFiboUr(l_high_28, ld_36, Ur2 / 100.0);
      ld_4 = ld_44;
      l_price_12 = ld_36 - StopLoss * Point;
      l_price_20 = ld_52;
      if (Ask - ld_4 < 5.0 * Point || Ask - l_price_12 < 5.0 * Point || l_price_20 - Ask < 5.0 * Point) return (0);
      l_ticket_0 = OrderSend(Symbol(), OP_BUYLIMIT, Lots(), NormalizeDouble(ld_4, Digits), 3, l_price_12, l_price_20, "Parabolic", MagicNumber, 0, Red);
      gi_unused_200 = 0;
   }
   if (l_isar_60 > Bid && l_isar_68 > Bid && gi_220 == TRUE) {
      gi_220 = FALSE;
      l_high_28 = MaximumMinimum(1, perMA);
      ld_36 = Low[1];
      ld_44 = GetFiboUr(ld_36, l_high_28, Ur1 / 100.0);
      ld_52 = GetFiboUr(ld_36, l_high_28, Ur2 / 100.0);
      ld_4 = ld_44;
      l_price_12 = l_high_28 + StopLoss * Point;
      l_price_20 = ld_52;
      if (ld_4 - Ask < 5.0 * Point || l_price_12 - Ask < 5.0 * Point || Ask - l_price_20 < 5.0 * Point) return (0);
      l_ticket_0 = OrderSend(Symbol(), OP_SELLLIMIT, Lots(), NormalizeDouble(ld_4, Digits), 3, l_price_12, l_price_20, "Parabolic", MagicNumber, 0, Red);
      gi_unused_204 = 0;
   }
   if (l_isar_68 > Bid && ChLimitOrder(1) > 0) l_ticket_0 = deletelimitorder(1);
   if (l_isar_68 < Bid && ChLimitOrder(0) > 0) l_ticket_0 = deletelimitorder(0);
   return (0);
}

int deletelimitorder(int ai_0) {
   int l_ord_delete_8;
   for (int li_4 = 1; li_4 <= OrdersTotal(); li_4++) {
      if (OrderSelect(li_4 - 1, SELECT_BY_POS) == TRUE) {
         if (OrderType() == OP_BUYLIMIT && OrderSymbol() == Symbol() && ai_0 == 1) l_ord_delete_8 = OrderDelete(OrderTicket());
         if (OrderType() == OP_SELLLIMIT && OrderSymbol() == Symbol() && ai_0 == 0) l_ord_delete_8 = OrderDelete(OrderTicket());
      }
   }
   return (l_ord_delete_8);
}

int ChLimitOrder(int ai_0) {
   for (int li_4 = 1; li_4 <= OrdersTotal(); li_4++) {
      if (OrderSelect(li_4 - 1, SELECT_BY_POS) == TRUE) {
         if (OrderType() == OP_BUYLIMIT && OrderSymbol() == Symbol() && ai_0 == 1) return (1);
         if (OrderType() == OP_SELLLIMIT && OrderSymbol() == Symbol() && ai_0 == 0) return (1);
      }
   }
   return (0);
}

double MaximumMinimum(int ai_0, int ai_4) {
   double ld_ret_16;
   int li_8 = 0;
   bool li_12 = FALSE;
   if (ai_0 == 0) {
      while (li_12 == FALSE) {
         ld_ret_16 = Low[iLowest(NULL, 0, MODE_LOW, ai_4, li_8)];
         if (ld_ret_16 > Low[iLowest(NULL, 0, MODE_LOW, ai_4, li_8 + ai_4)]) {
            ld_ret_16 = Low[iLowest(NULL, 0, MODE_LOW, ai_4, li_8 + ai_4)];
            li_8 += ai_4;
         } else {
            li_12 = TRUE;
            return (ld_ret_16);
         }
      }
   }
   if (ai_0 == 1) {
      while (li_12 == FALSE) {
         ld_ret_16 = High[iHighest(NULL, 0, MODE_HIGH, ai_4, li_8)];
         if (ld_ret_16 < High[iHighest(NULL, 0, MODE_HIGH, ai_4, li_8 + ai_4)]) {
            ld_ret_16 = High[iHighest(NULL, 0, MODE_HIGH, ai_4, li_8 + ai_4)];
            li_8 += ai_4;
         } else {
            li_12 = TRUE;
            return (ld_ret_16);
         }
      }
   }
   return (0);
}

double GetFiboUr(double ad_0, double ad_8, double ad_16) {
   double ld_28;
   int l_digits_24 = MarketInfo(Symbol(), MODE_DIGITS);
   ld_28 = NormalizeDouble(ad_8 + (ad_0 - ad_8) * ad_16, l_digits_24);
   return (ld_28);
}

int CheckTrailingStop() {
   for (int l_pos_0 = 0; l_pos_0 < OrdersTotal(); l_pos_0++) {
      if (OrderSelect(l_pos_0, SELECT_BY_POS)) {
         if (OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol()) {
            if (OrderType() == OP_BUY)
               if (Bid - OrderOpenPrice() > TrailingStop * Point && Bid - TrailingStop * Point - OrderStopLoss() >= Point) OrderModify(OrderTicket(), 0, Bid - TrailingStop * Point, OrderTakeProfit(), 0, C'0x02,0x00,0x00');
            if (OrderType() == OP_SELL)
               if (OrderOpenPrice() - Ask > TrailingStop * Point && OrderStopLoss() - Ask - TrailingStop * Point >= Point) OrderModify(OrderTicket(), 0, Ask + TrailingStop * Point, OrderTakeProfit(), 0, C'0x04,0x00,0x00');
         }
      }
   }
   return (0);
}